freedombone-app-tox 24KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # Tox Application
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2014-2016 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full full-vim chat'
  31. IN_DEFAULT_INSTALL=0
  32. SHOW_ON_ABOUT=1
  33. TOX_PORT=33445
  34. TOXCORE_REPO="https://github.com/bashrc/toxcore"
  35. TOXCORE_COMMIT='d3fa9f82bda3a8746917502c525237427ba17d45'
  36. TOXID_REPO="https://github.com/bashrc/toxid"
  37. TOX_BOOTSTRAP_ID_FILE=/var/lib/tox-bootstrapd/pubkey.txt
  38. # These are some default nodes, but you can replace them with trusted nodes
  39. # as you prefer. See https://wiki.tox.im/Nodes
  40. TOX_NODES=
  41. #TOX_NODES=(
  42. # '192.254.75.102,2607:5600:284::2,33445,951C88B7E75C867418ACDB5D273821372BB5BD652740BCDF623A4FA293E75D2F,Tox RELENG,US'
  43. # '144.76.60.215,2a01:4f8:191:64d6::1,33445,04119E835DF3E78BACF0F84235B300546AF8B936F035185E2A8E9E0A67C8924F,sonOfRa,DE'
  44. #)
  45. TOXIC_REPO="https://github.com/Tox/toxic"
  46. TOXIC_COMMIT='cf16849b374e484a33a4dffa3dfb937b59d537f2'
  47. TOXIC_FILE=/usr/local/bin/toxic
  48. QTOX_REPO="https://github.com/bashrc/qTox"
  49. QTOX_COMMIT='origin/bashrc/freedombone'
  50. tox_variables=(SYSTEM_TYPE
  51. TOXCORE_REPO
  52. MY_USERNAME
  53. ONION_ONLY
  54. INSTALLED_WITHIN_DOCKER
  55. TOX_PORT
  56. TOX_NODES)
  57. function remove_user_tox {
  58. remove_username="$1"
  59. if [ -d /home/$remove_username/.config/tox ]; then
  60. if [ -d /home/$remove_username/.config/tox/chatlogs ]; then
  61. shred -zu /home/$remove_username/.config/tox/chatlogs/*
  62. rm -rf /home/$remove_username/.config/tox/chatlogs
  63. fi
  64. shred -zu /home/$remove_username/.config/tox/*
  65. fi
  66. }
  67. function add_user_tox {
  68. new_username="$1"
  69. # Note: password isn't used
  70. new_user_password="$2"
  71. USER_TOX_FILE=/home/${new_username}/.config/tox/data.tox
  72. if [ ! -f $USER_TOX_FILE ]; then
  73. mkdir -p /home/${new_username}/.config/tox
  74. chown -R ${new_username}:${new_username} /home/${new_username}/.config
  75. su -c "toxid -u ${new_username} -n data" - $new_username
  76. su -c "toxid --setuser ${new_username}" - $new_username
  77. fi
  78. }
  79. function run_client_tox {
  80. # create a tox user
  81. USER_TOX_FILE=/home/${USER}/.config/tox/data.tox
  82. if [ ! -f $USER_TOX_FILE ]; then
  83. mkdir -p /home/${USER}/.config/tox
  84. chown -R ${USER}:${USER} /home/${USER}/.config
  85. toxid -u ${USER} -n data
  86. toxid --setuser ${USER}
  87. fi
  88. toxic -f $USER_TOX_FILE --force-tcp --SOCKS5-proxy 127.0.0.1 9050
  89. }
  90. function install_interactive_tox {
  91. echo -n ''
  92. APP_INSTALLED=1
  93. }
  94. function configure_interactive_tox {
  95. if [ ! -f $TOX_BOOTSTRAP_ID_FILE ]; then
  96. return
  97. fi
  98. bootstrap_id=$(cat $TOX_BOOTSTRAP_ID_FILE)
  99. dialog --title $"Tox Bootstrap Node ID" \
  100. --msgbox $"\n$bootstrap_id\n\nTo copy this hold down the shift key, select the ID and then right click and copy." 10 70
  101. }
  102. function mesh_tox_qtox {
  103. if [ ! ${rootdir}$INSTALL_DIR ]; then
  104. INSTALL_DIR=${rootdir}/root/build
  105. fi
  106. if [ ! -d ${rootdir}$INSTALL_DIR ]; then
  107. mkdir -p ${rootdir}$INSTALL_DIR
  108. fi
  109. chroot "${rootdir}" apt-get -yq install build-essential libatk1.0-0 libbz2-1.0 libc6 libcairo2 libdbus-1-3 libegl1-mesa libfontconfig1 libfreetype6 libgcc1 libgdk-pixbuf2.0-0 libgl1-mesa-glx libglib2.0-0 libgtk2.0-0 libice6 libicu52 libjpeg62-turbo libmng1 libmtdev1 libopenal1 libopus0 libpango-1.0-0 libpangocairo-1.0-0 libpangoft2-1.0-0 libpng12-0 libqrencode3 libsm6 libsodium13 libsqlite3-0 libssl1.0.0 libstdc++6 libtiff5 libudev1 libvpx1 libwayland-client0 libwayland-cursor0 libwayland-egl1-mesa libwebp5 libx11-6 libx11-xcb1 libxcb-glx0 libxcb-icccm4 libxcb-image0 libxcb-keysyms1 libxcb-randr0 libxcb-render-util0 libxcb-render0 libxcb-shape0 libxcb-shm0 libxcb-sync1 libxcb-xfixes0 libxcb-xinerama0 libxcb1 libxext6 libxfixes3 libxi6 libxrender1 libxss1 zlib1g libopus-dev libvpx-dev
  110. chroot "${rootdir}" apt-get -yq install build-essential qt5-qmake qt5-default qttools5-dev-tools libqt5opengl5-dev libqt5svg5-dev libopenal-dev libxss-dev qrencode libqrencode-dev libglib2.0-dev libgdk-pixbuf2.0-dev libgtk2.0-dev libsqlcipher-dev libopus-dev libvpx-dev libavformat-dev libavdevice-dev libswscale-dev libavutil-dev libavcodec-dev libavcodec56 libavcodec57 libavfilter-dev libavfilter6
  111. mesh_install_ffmpeg
  112. git clone $QTOX_REPO ${rootdir}$INSTALL_DIR/qtox
  113. if [ ! -d ${rootdir}$INSTALL_DIR/qtox ]; then
  114. exit 72428
  115. fi
  116. cd ${rootdir}${INSTALL_DIR}/qtox
  117. git checkout $QTOX_COMMIT -b $QTOX_COMMIT
  118. chroot ${rootdir} /bin/bash -x <<EOF
  119. cd ${INSTALL_DIR}/qtox
  120. qmake
  121. make
  122. make install
  123. EOF
  124. if [ ! -f ${rootdir}/usr/bin/qtox ]; then
  125. exit 75784
  126. fi
  127. }
  128. function reconfigure_tox {
  129. echo -n ''
  130. }
  131. function upgrade_tox {
  132. function_check set_repo_commit
  133. set_repo_commit $INSTALL_DIR/toxcore "toxcore commit" "$TOXCORE_COMMIT" $TOXCORE_REPO
  134. if [[ $(commit_has_changed $INSTALL_DIR/toxcore "toxcore commit" "$TOXCORE_COMMIT") == "1" ]]; then
  135. cd $INSTALL_DIR/toxcore
  136. sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' $rootdir/etc/systemd/system/tox-bootstrapd.service
  137. autoreconf -i
  138. ./configure --enable-daemon
  139. make
  140. make install
  141. systemctl daemon-reload
  142. systemctl restart tox-bootstrapd.service
  143. fi
  144. function_check set_repo_commit
  145. set_repo_commit $INSTALL_DIR/toxic "Toxic commit" "$TOXIC_COMMIT" $TOXIC_REPO
  146. if [[ $(commit_has_changed $INSTALL_DIR/toxic "Toxic commit" "$TOXIC_COMMIT") == "1" ]]; then
  147. cd $INSTALL_DIR/toxic
  148. make
  149. make install
  150. fi
  151. }
  152. function backup_local_tox {
  153. if [ -d /var/lib/tox-bootstrapd ]; then
  154. echo $"Backing up Tox"
  155. if [ -d /var/lib/tox-bootstrapd ]; then
  156. cp /etc/tox-bootstrapd.conf /var/lib/tox-bootstrapd
  157. if [ -d /var/lib/tox-bootstrapd/Maildir ]; then
  158. rm -rf /var/lib/tox-bootstrapd/Maildir
  159. fi
  160. fi
  161. function_check backup_directory_to_usb
  162. backup_directory_to_usb /var/lib/tox-bootstrapd tox
  163. echo $"Backup of Tox complete"
  164. fi
  165. }
  166. function restore_local_tox {
  167. if [ -d $USB_MOUNT/backup/tox ]; then
  168. echo $"Restoring Tox node settings"
  169. function_check restore_directory_from_usb
  170. restore_directory_from_usb / tox
  171. if [ ! "$?" = "0" ]; then
  172. function_check set_user_permissions
  173. set_user_permissions
  174. function_check backup_unmount_drive
  175. backup_unmount_drive
  176. exit 6393
  177. fi
  178. cp /var/lib/tox-bootstrapd/tox-bootstrapd.conf /etc/tox-bootstrapd.conf
  179. systemctl restart tox-bootstrapd.service
  180. if [ ! "$?" = "0" ]; then
  181. systemctl status tox-bootstrapd.service
  182. function_check set_user_permissions
  183. set_user_permissions
  184. function_check backup_unmount_drive
  185. backup_unmount_drive
  186. exit 59369
  187. fi
  188. fi
  189. }
  190. function backup_remote_tox {
  191. if [ -d /var/lib/tox-bootstrapd ]; then
  192. echo "Backing up Tox node settings"
  193. if [ -d /var/lib/tox-bootstrapd/Maildir ]; then
  194. rm -rf /var/lib/tox-bootstrapd/Maildir
  195. fi
  196. cp /etc/tox-bootstrapd.conf /var/lib/tox-bootstrapd
  197. backup_directory_to_friend /var/lib/tox-bootstrapd tox
  198. echo "Backup of Tox node settings complete"
  199. fi
  200. }
  201. function restore_remote_tox {
  202. if [ -d $SERVER_DIRECTORY/backup/tox ]; then
  203. echo $"Restoring Tox node settings"
  204. function_check restore_directory_from_friend
  205. restore_directory_from_friend / tox
  206. if [ ! "$?" = "0" ]; then
  207. exit 93653
  208. fi
  209. cp /var/lib/tox-bootstrapd/tox-bootstrapd.conf /etc/tox-bootstrapd.conf
  210. systemctl restart tox-bootstrapd.service
  211. if [ ! "$?" = "0" ]; then
  212. systemctl status tox-bootstrapd.service
  213. exit 59369
  214. fi
  215. echo $"Restore of Tox node complete"
  216. fi
  217. }
  218. function remove_tox_node {
  219. firewall_remove ${TOX_PORT}
  220. function_check remove_onion_service
  221. remove_onion_service tox ${TOX_PORT}
  222. ${PROJECT_NAME}-mesh-install -f tox_node --remove yes
  223. if [ ! "$?" = "0" ]; then
  224. echo $'Failed to remove tox node'
  225. exit 763836
  226. fi
  227. remove_completion_param install_tox_node
  228. remove_completion_param configure_firewall_for_tox
  229. }
  230. function remove_tox_avahi {
  231. cd $INSTALL_DIR/toxid
  232. make uninstall
  233. rm -rf $INSTALL_DIR/toxid
  234. sed -i '/tox_avahi/d' $COMPLETION_FILE
  235. }
  236. function remove_tox_client {
  237. ${PROJECT_NAME}-mesh-install -f tox_client --remove yes
  238. if [ ! "$?" = "0" ]; then
  239. echo $'Could not remove Tox client'
  240. exit 737253
  241. fi
  242. sed -i '/install_tox_client/d' $COMPLETION_FILE
  243. sed -i '/Tox /d' $COMPLETION_FILE
  244. sed -i '/Toxic /d' $COMPLETION_FILE
  245. }
  246. function remove_tox {
  247. remove_tox_client
  248. remove_tox_avahi
  249. remove_tox_node
  250. }
  251. function configure_firewall_for_tox {
  252. if [ ! $INSTALLING_MESH ]; then
  253. if [[ $(is_completed $FUNCNAME) == "1" ]]; then
  254. return
  255. fi
  256. fi
  257. if [[ $INSTALLED_WITHIN_DOCKER == "yes" ]]; then
  258. # docker does its own firewalling
  259. return
  260. fi
  261. if [[ $ONION_ONLY != "no" ]]; then
  262. return
  263. fi
  264. TOX_PORT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  265. if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
  266. TOX_PORT=$TOX_PORT_MAIN
  267. fi
  268. if [ ! $TOX_PORT ]; then
  269. echo $'No Tox port was specified'
  270. exit 32856
  271. fi
  272. firewall_add Tox ${TOX_PORT}
  273. mark_completed $FUNCNAME
  274. }
  275. function tox_avahi {
  276. if [[ $(is_completed $FUNCNAME) == "1" ]]; then
  277. return
  278. fi
  279. if [ ! -d /etc/avahi ]; then
  280. echo $'tox_avahi: avahi is not installed'
  281. exit 87359
  282. fi
  283. # install a command to obtain the Tox ID
  284. cd $INSTALL_DIR
  285. function_check git_clone
  286. git_clone $TOXID_REPO $INSTALL_DIR/toxid
  287. if [ ! -d $INSTALL_DIR/toxid ]; then
  288. exit 63921
  289. fi
  290. cd $INSTALL_DIR/toxid
  291. make
  292. if [ ! "$?" = "0" ]; then
  293. exit 58432
  294. fi
  295. make install
  296. if [[ $SYSTEM_TYPE == "mesh"* ]]; then
  297. toxavahi
  298. # publish regularly
  299. function_check cron_add_mins
  300. cron_add_mins 1 'toxavahi 2> /dev/null'
  301. fi
  302. systemctl restart avahi-daemon
  303. mark_completed $FUNCNAME
  304. }
  305. function install_tox_node {
  306. if [[ $(app_is_installed tox_node) == "1" ]]; then
  307. return
  308. fi
  309. function_check mesh_tox_node
  310. mesh_tox_node
  311. # onion address for bootstrapping
  312. TOX_ONION_HOSTNAME=$(add_onion_service tox ${TOX_PORT} ${TOX_PORT})
  313. systemctl restart tox-bootstrapd.service
  314. sleep 3
  315. TOX_PUBLIC_KEY=$(cat /var/log/syslog | grep tox | grep "Public Key" | tail -n 1 | awk -F ' ' '{print $8}')
  316. if [ ${#TOX_PUBLIC_KEY} -lt 30 ]; then
  317. echo $'Could not obtain the tox node public key'
  318. exit 6529
  319. fi
  320. # save the public key for later reference
  321. echo "$TOX_PUBLIC_KEY" > $TOX_BOOTSTRAP_ID_FILE
  322. function_check configure_firewall_for_tox
  323. configure_firewall_for_tox
  324. function_check configure_firewall_for_tox
  325. configure_firewall_for_tox
  326. install_completed tox_node
  327. }
  328. function install_tox_client {
  329. if [[ $(app_is_installed tox_client) == "1" ]]; then
  330. return
  331. fi
  332. function_check mesh_tox_client
  333. mesh_tox_client
  334. install_completed tox_client
  335. }
  336. function mesh_tox_node {
  337. # obtain commits from the main file
  338. TOXCORE_COMMIT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXCORE_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  339. if [ ${#TOXCORE_COMMIT_MAIN} -gt 10 ]; then
  340. TOXCORE_COMMIT=$TOXCORE_COMMIT_MAIN
  341. fi
  342. if [ ! $TOXCORE_COMMIT ]; then
  343. echo $'No Tox commit was specified'
  344. exit 76325
  345. fi
  346. TOXID_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  347. if [ ${#TOXID_REPO_MAIN} -gt 5 ]; then
  348. TOXID_REPO=$TOXID_REPO_MAIN
  349. fi
  350. if [ ! $TOXID_REPO ]; then
  351. echo $'No ToxID repo was specified'
  352. exit 78252
  353. fi
  354. TOX_PORT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  355. if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
  356. TOX_PORT=$TOX_PORT_MAIN
  357. fi
  358. if [ ! $TOX_PORT ]; then
  359. echo $'No Tox port was specified'
  360. exit 32856
  361. fi
  362. TOXCORE_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXCORE_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  363. if [ ${#TOXCORE_REPO_MAIN} -gt 10 ]; then
  364. TOXCORE_REPO=$TOXCORE_REPO_MAIN
  365. fi
  366. if [ ! $TOXCORE_REPO ]; then
  367. echo $'No Tox repo was specified'
  368. exit 16865
  369. fi
  370. if [ ! $TOXCORE_COMMIT ]; then
  371. echo $'No Tox commit was specified'
  372. exit 76325
  373. fi
  374. if [ ! $TOXCORE_REPO ]; then
  375. echo $'No Tox repo was specified'
  376. exit 16865
  377. fi
  378. if [ $rootdir ]; then
  379. chroot ${rootdir} apt-get -yq install build-essential libtool autotools-dev
  380. chroot ${rootdir} apt-get -yq install automake checkinstall check git yasm
  381. chroot ${rootdir} apt-get -yq install libsodium13 libsodium-dev libcap2-bin
  382. chroot ${rootdir} apt-get -yq install libconfig9 libconfig-dev autoconf
  383. chroot ${rootdir} apt-get -yq install libopus-dev libvpx-dev
  384. else
  385. apt-get -yq install build-essential libtool autotools-dev
  386. apt-get -yq install automake checkinstall check git yasm
  387. apt-get -yq install libsodium13 libsodium-dev libcap2-bin
  388. apt-get -yq install libconfig9 libconfig-dev autoconf
  389. apt-get -yq install libopus-dev libvpx-dev
  390. fi
  391. if [ ! -d ${rootdir}${INSTALL_DIR} ]; then
  392. mkdir -p ${rootdir}${INSTALL_DIR}
  393. fi
  394. if [ ! -d ${rootdir}${INSTALL_DIR}/toxcore ]; then
  395. git clone ${TOXCORE_REPO} ${rootdir}${INSTALL_DIR}/toxcore
  396. if [ ! "$?" = "0" ]; then
  397. exit 429252
  398. fi
  399. fi
  400. cd ${rootdir}$INSTALL_DIR/toxcore
  401. git checkout $TOXCORE_COMMIT -b $TOXCORE_COMMIT
  402. if [ ${rootdir} ]; then
  403. chroot ${rootdir} /bin/bash -x <<EOF
  404. cd ${INSTALL_DIR}/toxcore
  405. autoreconf -i
  406. ./configure --enable-daemon
  407. make
  408. make install
  409. EOF
  410. else
  411. /bin/bash -x <<EOF
  412. cd ${INSTALL_DIR}/toxcore
  413. autoreconf -i
  414. ./configure --enable-daemon
  415. make
  416. make install
  417. EOF
  418. fi
  419. cp $rootdir/usr/local/lib/libtoxcore* $rootdir/usr/lib/
  420. cp ${rootdir}${INSTALL_DIR}/toxcore/other/bootstrap_daemon/tox-bootstrapd.service $rootdir/etc/systemd/system/
  421. sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' $rootdir/etc/systemd/system/tox-bootstrapd.service
  422. if [ ${rootdir} ]; then
  423. chroot ${rootdir} systemctl enable tox-bootstrapd.service
  424. else
  425. systemctl enable tox-bootstrapd.service
  426. fi
  427. SECONDS=0
  428. if [ ! -f $rootdir/usr/local/bin/tox-bootstrapd ]; then
  429. duration=$SECONDS
  430. echo $"Toxcore compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  431. echo $'Unable to make toxcore'
  432. exit 73835
  433. fi
  434. duration=$SECONDS
  435. echo $"Toxcore compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  436. if [ ${rootdir} ]; then
  437. chroot ${rootdir} /usr/sbin/useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
  438. chroot ${rootdir} /bin/chmod 700 /var/lib/tox-bootstrapd
  439. else
  440. chmod 600 /etc/shadow
  441. chmod 600 /etc/gshadow
  442. useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
  443. chmod 0000 /etc/shadow
  444. chmod 0000 /etc/gshadow
  445. chmod 700 /var/lib/tox-bootstrapd
  446. fi
  447. # remove Maildir
  448. if [ -d $rootdir/var/lib/tox-bootstrapd/Maildir ]; then
  449. rm -rf $rootdir/var/lib/tox-bootstrapd/Maildir
  450. fi
  451. # create configuration file
  452. TOX_BOOTSTRAP_CONFIG=$rootdir/etc/tox-bootstrapd.conf
  453. echo "port = $TOX_PORT" > $TOX_BOOTSTRAP_CONFIG
  454. echo 'keys_file_path = "/var/lib/tox-bootstrapd/keys"' >> $TOX_BOOTSTRAP_CONFIG
  455. echo 'pid_file_path = "/var/run/tox-bootstrapd/tox-bootstrapd.pid"' >> $TOX_BOOTSTRAP_CONFIG
  456. echo 'enable_ipv6 = true' >> $TOX_BOOTSTRAP_CONFIG
  457. echo 'enable_ipv4_fallback = true' >> $TOX_BOOTSTRAP_CONFIG
  458. echo 'enable_lan_discovery = true' >> $TOX_BOOTSTRAP_CONFIG
  459. echo 'enable_tcp_relay = true' >> $TOX_BOOTSTRAP_CONFIG
  460. echo "tcp_relay_ports = [443, 3389, $TOX_PORT]" >> $TOX_BOOTSTRAP_CONFIG
  461. echo 'enable_motd = true' >> $TOX_BOOTSTRAP_CONFIG
  462. echo 'motd = "tox-bootstrapd"' >> $TOX_BOOTSTRAP_CONFIG
  463. if [ $TOX_NODES ]; then
  464. echo 'bootstrap_nodes = (' >> $TOX_BOOTSTRAP_CONFIG
  465. toxcount=0
  466. while [ "x${TOX_NODES[toxcount]}" != "x" ]
  467. do
  468. toxval_ipv4=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $1}')
  469. toxval_ipv6=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $2}')
  470. toxval_port=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $3}')
  471. toxval_pubkey=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $4}')
  472. toxval_maintainer=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $5}')
  473. echo "{ // $toxval_maintainer" >> $TOX_BOOTSTRAP_CONFIG
  474. if [[ $toxval_ipv6 != 'NONE' ]]; then
  475. echo " address = \"$toxval_ipv6\"" >> $TOX_BOOTSTRAP_CONFIG
  476. else
  477. echo " address = \"$toxval_ipv4\"" >> $TOX_BOOTSTRAP_CONFIG
  478. fi
  479. echo " port = $toxval_port" >> $TOX_BOOTSTRAP_CONFIG
  480. echo " public_key = \"$toxval_pubkey\"" >> $TOX_BOOTSTRAP_CONFIG
  481. toxcount=$(( $toxcount + 1 ))
  482. if [ "x${TOX_NODES[toxcount]}" != "x" ]; then
  483. echo "}," >> $TOX_BOOTSTRAP_CONFIG
  484. else
  485. echo "}" >> $TOX_BOOTSTRAP_CONFIG
  486. fi
  487. done
  488. echo ')' >> $TOX_BOOTSTRAP_CONFIG
  489. fi
  490. if [ -f $rootdir/var/lib/tox-bootstrapd/keys ]; then
  491. chmod 700 $rootdir/var/lib/tox-bootstrapd/keys
  492. fi
  493. }
  494. function mesh_tox_avahi {
  495. if [ ! -d $rootdir/etc/avahi ]; then
  496. echo $'tox_avahi: avahi is not installed'
  497. exit 87359
  498. fi
  499. if [ ! $TOXID_REPO ]; then
  500. echo $'No ToxID repo was specified'
  501. exit 78252
  502. fi
  503. if [ ! -d ${rootdir}${INSTALL_DIR} ]; then
  504. mkdir -p ${rootdir}${INSTALL_DIR}
  505. fi
  506. git clone ${TOXID_REPO} ${rootdir}${INSTALL_DIR}/toxid
  507. if [ ! -d ${rootdir}${INSTALL_DIR}/toxid ]; then
  508. echo $'Unable to clone toxid repo'
  509. exit 768352
  510. fi
  511. if [ ${rootdir} ]; then
  512. chroot ${rootdir} /bin/bash -x <<EOF
  513. cd ${INSTALL_DIR}/toxid
  514. make
  515. make install
  516. EOF
  517. else
  518. /bin/bash -x <<EOF
  519. cd ${INSTALL_DIR}/toxid
  520. make
  521. make install
  522. EOF
  523. fi
  524. if [ ! -f $rootdir/usr/local/bin/toxid ]; then
  525. echo $'toxid not found'
  526. exit 74370
  527. fi
  528. if [ ! -f $rootdir/usr/local/bin/toxavahi ]; then
  529. exit 3621729
  530. fi
  531. MESH_SYNC_COMMAND=$rootdir/usr/bin/mesh-sync
  532. echo '#!/bin/bash' > $MESH_SYNC_COMMAND
  533. echo '/usr/local/bin/toxavahi 2> /dev/null' >> $MESH_SYNC_COMMAND
  534. echo '/usr/local/bin/meshavahi 2> /dev/null' >> $MESH_SYNC_COMMAND
  535. chmod +x $MESH_SYNC_COMMAND
  536. if ! grep -q "mesh-sync" ${rootdir}/etc/crontab; then
  537. echo "*/1 * * * * root /usr/bin/mesh-sync 2> /dev/null" >> ${rootdir}/etc/crontab
  538. echo "*/1 * * * * root ( sleep 20 ; /usr/bin/mesh-sync 2> /dev/null )" >> ${rootdir}/etc/cro echo "*/1 * * * * root ( sleep 40 ; /usr/bin/mesh-sync 2> /dev/null )" >> ${rootdir}/etc/crontab
  539. fi
  540. }
  541. function mesh_tox_client {
  542. TOXIC_FILE=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  543. # obtain commits from the main file
  544. TOXIC_COMMIT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  545. if [ ${#TOXIC_COMMIT_MAIN} -gt 10 ]; then
  546. TOXIC_COMMIT=$TOXIC_COMMIT_MAIN
  547. fi
  548. TOXIC_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  549. if [ ${#TOXIC_REPO_MAIN} -gt 5 ]; then
  550. TOXIC_REPO=$TOXIC_REPO_MAIN
  551. fi
  552. if [ ${rootdir} ]; then
  553. chroot ${rootdir} apt-get -yq install libncursesw5-dev libconfig-dev libqrencode-dev
  554. chroot ${rootdir} apt-get -yq install libcurl4-openssl-dev libvpx-dev libopenal-dev
  555. else
  556. apt-get -yq install libncursesw5-dev libconfig-dev libqrencode-dev
  557. apt-get -yq install libcurl4-openssl-dev libvpx-dev libopenal-dev
  558. fi
  559. TEMP_SCRIPT_NAME=fbtmp728353.sh
  560. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  561. echo '#!/bin/bash' > $TEMP_SCRIPT
  562. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  563. echo "git clone $TOXIC_REPO $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  564. echo "cd $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  565. echo "git checkout $TOXIC_COMMIT -b $TOXIC_COMMIT" >> $TEMP_SCRIPT
  566. echo 'make' >> $TEMP_SCRIPT
  567. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  568. echo ' exit 1' >> $TEMP_SCRIPT
  569. echo 'fi' >> $TEMP_SCRIPT
  570. echo 'make install' >> $TEMP_SCRIPT
  571. echo 'exit 0' >> $TEMP_SCRIPT
  572. chmod +x $TEMP_SCRIPT
  573. cp $TEMP_SCRIPT $rootdir/root/
  574. TOXIC_FILE=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  575. SECONDS=0
  576. if [ ${rootdir} ]; then
  577. chroot ${rootdir} /root/$TEMP_SCRIPT_NAME
  578. else
  579. /root/$TEMP_SCRIPT_NAME
  580. fi
  581. if [ ! "$?" = "0" ]; then
  582. duration=$SECONDS
  583. echo $"Toxic client compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  584. echo $'Unable to make tox client'
  585. rm $TEMP_SCRIPT
  586. exit 74872
  587. fi
  588. rm $TEMP_SCRIPT
  589. if [ ! -f $rootdir$TOXIC_FILE ]; then
  590. echo $"Tox client was not installed to $TOXIC_FILE"
  591. exit 63278
  592. fi
  593. duration=$SECONDS
  594. echo $"Toxic client compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  595. }
  596. function enable_tox_repo {
  597. echo 'deb http://download.opensuse.org/repositories/home:/antonbatenev:/tox/Debian_8.0/ /' > $rootdir/etc/apt/sources.list.d/tox.list
  598. cat >> $rootdir/root/gettoxkey.sh <<EOF
  599. #!/bin/bash
  600. wget -q http://download.opensuse.org/repositories/home:antonbatenev:tox/Debian_8.0/Release.key -O- > /root/tox.key
  601. apt-key add /root/tox.key
  602. rm /root/tox.key
  603. EOF
  604. chroot "$rootdir" chmod +x /root/gettoxkey.sh
  605. chroot "$rootdir" /root/gettoxkey.sh
  606. chroot "$rootdir" apt-get update
  607. echo "Tox Repository Installed."
  608. }
  609. function install_tox {
  610. configure_firewall_for_tox
  611. if [ $INSTALLING_MESH ]; then
  612. mesh_tox_node
  613. mesh_tox_avahi
  614. mesh_tox_client
  615. else
  616. avoid_tor_restart=
  617. if [ -f $IMAGE_PASSWORD_FILE ]; then
  618. if [[ $ONION_ONLY != 'no' ]]; then
  619. avoid_tor_restart=1
  620. fi
  621. fi
  622. if [ $avoid_tor_restart ]; then
  623. ${PROJECT_NAME}-logging on --onion
  624. else
  625. ${PROJECT_NAME}-logging on
  626. fi
  627. install_tox_node
  628. if [ $avoid_tor_restart ]; then
  629. ${PROJECT_NAME}-logging off --onion
  630. else
  631. ${PROJECT_NAME}-logging off
  632. fi
  633. tox_avahi
  634. install_tox_client
  635. fi
  636. APP_INSTALLED=1
  637. }
  638. # NOTE: deliberately no exit 0